<?php
/*******************************************************************************/
//                          InstantCMS v1.9                                    //
//                      http://www.instantcms.ru/                              //
//                         plugin p_contextlinks v2.2                          //
//                     written by Marat Fatikhov  aka                     //
//					   modified by googlebot                                   //
//                     http://www.instantcms.ru/users/marat                    //
//                       E-mail: f-marat@mail.ru                               //
//                                                                             //
//                      LICENSED BY GNU/GPL v2                                 //
//                                                                             //
/********************************************************************************/

class p_contextlinks extends cmsPlugin {

// ==================================================================== //

    public function __construct(){
        
        parent::__construct();

        //   

        $this->info['plugin']           = 'p_contextlinks';
        $this->info['title']            = ' ';
        $this->info['description']      = '     ';
        $this->info['author']           = 'Marat Fatikhov & googlebot';
        $this->info['version']          = '2.2';

        //  -

        $this->config['||(.)<br /> ()  . ']   = " |neftekamcy.ru \n  |/ \n |/|1 \n";
        $this->config['   .  - ']   = '';
		$this->config[' ']   = 1;
		$this->config['  ']   = 1;
		$this->config['']   = 1;
		$this->config['']   = 1;
		$this->config[' ']   = 1;
		$this->config['']   = 1;
		$this->config[' ']   = 1;
		$this->config[' InstantMaps']   = 1;

        // ,    

        $this->events[]                 = 'GET_POSTS';
        $this->events[]                 = 'GET_POST';
        $this->events[]                 = 'GET_LATEST_POSTS';
        $this->events[]                 = 'GET_BEST_POSTS';
        $this->events[]                 = 'GET_COMMENTS';
        $this->events[]                 = 'GET_FORUM_POSTS';
        $this->events[]                 = 'GET_WALL_POSTS';
        $this->events[]                 = 'GET_ARTICLE';
        $this->events[]                 = 'GET_ARTICLES';
		$this->events[]                 = 'GET_MAP_OBJECT';

    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function install(){

        return parent::install();

    }

// ==================================================================== //

    /**
     *   
     * @return bool
     */
    public function upgrade(){

        return parent::upgrade();

    }

// ==================================================================== //

    /**
     *  
     * @param string $event
     * @param mixed $item
     * @return mixed
     */
    public function execute($event, $item){

        parent::execute();

        switch ($event){
            case 'GET_POST': if($this->config[' ']!= 0){$item = $this->eventGetPost($item);} break;
            case 'GET_POSTS': if($this->config['  ']!= 0){$item = $this->eventGetPosts($item);} break;
            case 'GET_LATEST_POSTS': if($this->config['  ']!= 0){$item = $this->eventGetPosts($item);} break;
            case 'GET_BEST_POSTS': if($this->config['  ']!= 0){$item = $this->eventGetPosts($item);} break;
            case 'GET_COMMENTS': if($this->config['']!= 0){$item = $this->eventGetComments($item);} break;
            case 'GET_FORUM_POSTS': if($this->config['']!= 0){$item = $this->eventGetComments($item);} break;
            case 'GET_WALL_POSTS': if($this->config[' ']!= 0){$item = $this->eventGetComments($item);} break;
            case 'GET_ARTICLE': if($this->config['']!= 0){$item = $this->eventGetArticle($item);} break;
            case 'GET_ARTICLES': if($this->config[' ']!= 0){$item = $this->eventGetArticles($item);} break;
			case 'GET_MAP_OBJECT': if($this->config[' InstantMaps']!= 0){$item = $this->eventGetMapObject($item);} break;
        }

        return $item;

    }

// ==================================================================== //

    private function makeLink($text){

        $string        = trim($this->config['||(.)<br /> ()  . ']);
		if (!$string) { return $text; }
        $limit          = $this->config['   .  - '];

        $toArray = explode("\n", $string);
        for($i=0; $i<sizeof($toArray); $i++){
            list($pattern[$i],$replacement[$i],$quant[$i]) = explode("|", trim($toArray[$i]));
        }
        //   1     . 
        for($i=0; $i<sizeof($replacement); $i++){
            $replacement[$i] = htmlspecialchars(strip_tags(trim($replacement[$i])));
			$quant[$i] = intval(trim($quant[$i]));
			if($replacement[$i]{0} != '/'){
            $replacement[$i] = 'http://'.str_replace('http://', '', $replacement[$i]);
			} else {$replacement[$i] = 'http://'.$_SERVER['HTTP_HOST'].$replacement[$i];}
			//   
			if ($replacement[$i] == 'http://'.$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI']){
				$ind[$i] = $i;
			} else {
				if (!is_numeric($quant[$i])||$quant[$i] == 0) {
					$pattern[$i] = '/\b('.trim($pattern[$i]).')\b/is';
					$replacement[$i] = '<a href="'.$replacement[$i].'">$1</a>';
				} else {
					$pattern[$i] = '/\b([A-Za-z--߸0-9]{0,'.$quant[$i].'})('.trim($pattern[$i]).')([A-Za-z--߸0-9]{0,'.$quant[$i].'})\b/is';
					$replacement[$i] = '<a href="'.$replacement[$i].'">$1$2$3</a>';
				}
			}
        }
		// 
		if (is_array($ind)) {
			foreach($ind as $i) {
				unset ($replacement[$i], $pattern[$i]);
			}
			$pattern = array_values($pattern);
			$replacement = array_values($replacement);
		}

        //      ,   
        if(count($pattern) != count($replacement)){ return $text; }

        //,  
        if(!is_numeric($limit)){ $limit = -1; }
        
		//      
		$regexp = '/(<a\s+[^>]*>[\W\w]*?<\/a>|<iframe[^>]*>[\W\w]*?<\/iframe>|<script[^>]*>[\W\w]*?<\/script>|<object[^>]*>[\W\w]*?<\/object>|<embed[^>]*>[\W\w]*?<\/embed>|<[^>]*?>)/i';
		preg_match_all($regexp, $text, $remember);
		
		//     
		$placeholder = '{placeholder}';
		$text = preg_replace($regexp, $placeholder, $text);

        //     
		$text = preg_replace($pattern, $replacement, $text, $limit);

		//  
		$p = '/('.$placeholder.')/';
		if (count($remember[0])){
			foreach($remember[0] as $r){
				$text = preg_replace($p, $r, $text, 1);
				}
			}

		return $text;

    }

    private function eventGetPost($item) {

        if (!is_array($item)){ return $item; }

        $item['content_html'] = $this->makeLink($item['content_html']);

        return $item;

    }

    private function eventGetPosts($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['content_html'] = $this->makeLink($item['content_html']);
        }
        
        return $items;
    }

    private function eventGetComments($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['content'] = $this->makeLink($item['content']);
        }

        return $items;
    }
    
    private function eventGetArticle($item){

        if (!is_array($item)){ return $item; }

           $item['content'] = $this->makeLink($item['content']);

        return $item;
    }
    
    private function eventGetArticles($items){

        if (!is_array($items)){ return $items; }

        foreach($items as $i=>$item){
            $items[$i]['description'] = $this->makeLink($item['description']);
        }

        return $items;
    }
    
    private function eventGetMapObject($item){

        if (!is_array($item)){ return $item; }

           $item['description'] = $this->makeLink($item['description']);

        return $item;
    }
   
// ==================================================================== //

}

?>
